/* ------------------------------------------------------------------------
 * Copyright 2013 Tim Vernum
 * ------------------------------------------------------------------------
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ------------------------------------------------------------------------
 */
package org.adjective.syntactic.convert.j8to7.type;

import org.adjective.syntactic.parser.util.ModifierSet;

import java.util.ArrayList;
import java.util.Collection;

public abstract class AbstractTypeInfo implements TypeInfo
{
    @Override
    public Collection<MethodInfo> getAbstractMethods()
    {
        final MethodInfo[] methods = getMethods();
        Collection<MethodInfo> filter = new ArrayList<MethodInfo>(1);
        for (final MethodInfo method : methods)
        {
            if (method.getModifiers().is(ModifierSet.Modifier.ABSTRACT))
            {
                filter.add(method);
            }
        }
        return filter;
    }

    @Override
    public MethodInfo findMethod(final String identifier, final int parameterCount)
    {
        for (MethodInfo method : getMethods())
        {
            if (identifier.equals(method.getName()) && method.getParameterCount() == parameterCount)
            {
                return method;
            }
        }
        return null;
    }
}
