/* ------------------------------------------------------------------------
 * Copyright 2013 Tim Vernum
 * ------------------------------------------------------------------------
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ------------------------------------------------------------------------
 */
package org.adjective.syntactic.convert.j8to7.util;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

public class ClassPath
{
    private final URL[] _urls;

    public ClassPath(String classpath) throws MalformedURLException
    {
        final String[] split = classpath.split(":");
        _urls = new URL[split.length];
        for (int i = 0; i < split.length; i++)
        {
            _urls[i] = getUrl(split[i]);
        }
    }

    private URL getUrl(final String s) throws MalformedURLException
    {
        return new File(s).toURI().toURL();
    }

    public URL[] getUrls()
    {
        return _urls;
    }
}
