package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;

import java.util.Map;

public abstract class ASTAnnotation extends BaseNode
{
    public ASTAnnotation(int id)
    {
        super(id);
    }

    @Override
    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTQualifiedIdentifier getName()
    {
        return child(ASTQualifiedIdentifier.class);
    }

    public abstract Map<ASTIdentifier, ASTMemberValue> getValues();
}
