package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.type.DeclarationType;
import org.adjective.syntactic.parser.node.IsTypeDeclaration;
import org.adjective.syntactic.parser.type.MemberType;

public class ASTAnnotationTypeDeclaration extends BaseNode implements IsTypeDeclaration
{
    public ASTAnnotationTypeDeclaration(int id)
    {
        super(id);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public DeclarationType getDeclarationType()
    {
        return DeclarationType.ANNOTATION;
    }

    @Override
    public MemberType getMemberType()
    {
        return MemberType.ANNOTATION;
    }
}
