package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;
import org.adjective.syntactic.parser.node.Nodes;

public class ASTArgumentList extends BaseNode
{
    public ASTArgumentList(int id)
    {
        super(id);
    }

    public ASTArgumentList(ASTExpression... arguments)
    {
        this(JavaParserTreeConstants.JJTARGUMENTLIST);
        setChildren(arguments);
    }

    public ASTArgumentList(ExpressionNode... arguments)
    {
        this(ASTExpression.array(arguments));
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public Nodes<ASTExpression> getArguments()
    {
        return allChildren(ASTExpression.class);
    }
}
