package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.StatementNode;

public class ASTBlock extends BaseNode implements StatementNode
{
    public ASTBlock(int id)
    {
        super(id);
    }

    public ASTBlock(final StatementNode... statements)
    {
        this(JavaParserTreeConstants.JJTBLOCK);
        setChildren(statements);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public Iterable<? extends StatementNode> statements()
    {
        return super.allChildren(StatementNode.class);
    }
}
