package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.jj.JavaParserConstants;
import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;

public class ASTBooleanLiteral extends BaseNode implements ExpressionNode
{
    public ASTBooleanLiteral(int id)
    {
        super(id);
    }

    public ASTBooleanLiteral(boolean value)
    {
        this(JavaParserTreeConstants.JJTBOOLEANLITERAL);
        if (value)
        {
            jjtSetFirstToken(makeToken(JavaParserConstants.TRUE,
                                       "true"));
        }
        else
        {
            jjtSetFirstToken(makeToken(JavaParserConstants.FALSE,
                                       "false"));
        }
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public boolean getValue()
    {
        return jjtGetFirstToken().kind == JavaParserConstants.TRUE;
    }
}
