package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;
import org.adjective.syntactic.parser.node.TypeNode;

public class ASTCastExpression extends BaseNode implements ExpressionNode
{
    public ASTCastExpression(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public TypeNode getType()
    {
        return getFirstChild().as(TypeNode.class);
    }

    public ExpressionNode getExpression()
    {
        return getLastChild().as(ExpressionNode.class);
    }
}
