package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.HasAnnotations;
import org.adjective.syntactic.parser.node.HasModifiers;
import org.adjective.syntactic.parser.util.ModifierSet;

public class ASTCatchParameter extends BaseNode implements HasModifiers, HasAnnotations
{
    public ASTCatchParameter(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public Iterable<ASTAnnotation> getAnnotations()
    {
        return getModifiersNode().getAnnotations();
    }

    @Override
    public ModifierSet getModifiers()
    {
        return getModifiersNode().getModifiers();
    }

    public ASTVariableModifiers getModifiersNode()
    {
        return getFirstChild().as(ASTVariableModifiers.class);
    }

    public ASTCatchType getExceptionType()
    {
        return child(1).as(ASTCatchType.class);
    }

    public ASTIdentifier getName()
    {
        return getLastChild().as(ASTIdentifier.class);
    }
}
