package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;

public class ASTClassOrInterfaceBodyElement extends BaseNode
{
    public ASTClassOrInterfaceBodyElement(int id)
    {
        super(id);
    }

    public ASTClassOrInterfaceBodyElement(final ASTMember member)
    {
        this(JavaParserTreeConstants.JJTCLASSORINTERFACEBODYELEMENT);
        jjtAddChild(member, 0);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public boolean isInitializer()
    {
        return !isEmpty() && super.getFirstChild().is(ASTInitializer.class);
    }

    public boolean isMember()
    {
        return !isEmpty() && super.getFirstChild().is(ASTMember.class);
    }

    public ASTInitializer getInitializer()
    {
        return super.getFirstChild().as(ASTInitializer.class);
    }

    public ASTMember getMember()
    {
        return super.getFirstChild().as(ASTMember.class);
    }
}
