package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;

public class ASTCompilationUnit extends BaseNode
{
    public ASTCompilationUnit(int id)
    {
        super(id);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTPackageDeclaration getPackage()
    {
        return optionalChild(ASTPackageDeclaration.class);
    }

    public Iterable<ASTImportDeclaration> getImports()
    {
        return child(ASTImports.class).getImports();
    }

    public Iterable<ASTTypeDeclaration> getDeclaredTypes()
    {
        return getTypesNode().getDeclaredTypes();
    }

    public ASTTypes getTypesNode()
    {
        return child(ASTTypes.class);
    }

    public ASTImports getImportsNode()
    {
        return child(ASTImports.class);
    }
}
