package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.IsMember;
import org.adjective.syntactic.parser.type.MemberType;

public class ASTConstructorDeclaration extends BaseNode implements IsMember
{
    public ASTConstructorDeclaration(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public MemberType getMemberType()
    {
        return MemberType.CONSTRUCTOR;
    }

    public ASTTypeParameters getTypeParameters()
    {
        return optionalChild(ASTTypeParameters.class);
    }

    public ASTIdentifier getName()
    {
        return child(ASTIdentifier.class);
    }

    public ASTFormalParameters getParameters()
    {
        return child(ASTFormalParameters.class);
    }

    public boolean hasExceptions()
    {
        return getExceptions() != null;
    }

    public ASTNameList getExceptions()
    {
        return optionalChild(ASTNameList.class);
    }

    public ASTConstructorBody getBody()
    {
        return getLastChild().as(ASTConstructorBody.class);
    }
}
