package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.StatementNode;

public class ASTDoStatement extends BaseNode implements StatementNode
{
    public ASTDoStatement(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public StatementNode getBody()
    {
        return getFirstChild().as(StatementNode.class);
    }

    public ASTExpression getCondition()
    {
        return child(1).as(ASTExpression.class);
    }
}
