package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.HasAnnotations;
import org.adjective.syntactic.parser.node.HasModifiers;
import org.adjective.syntactic.parser.util.ModifierSet;

public class ASTEnumConstant extends BaseNode implements HasAnnotations, HasModifiers
{
    public ASTEnumConstant(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public Iterable<ASTAnnotation> getAnnotations()
    {
        return getModifiersNode().getAnnotations();
    }

    @Override
    public ModifierSet getModifiers()
    {
        return getModifiersNode().getModifiers();
    }

    private ASTModifiers getModifiersNode()
    {
        return getFirstChild().as(ASTModifiers.class);
    }

    public ASTIdentifier getName()
    {
        return child(1).as(ASTIdentifier.class);
    }

    public ASTArguments getConstructorArguments()
    {
        return optionalChild(ASTArguments.class);
    }

    public ASTClassOrInterfaceBody getBody()
    {
        return optionalChild(ASTClassOrInterfaceBody.class);
    }
}
