package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.type.DeclarationType;
import org.adjective.syntactic.parser.node.IsTypeDeclaration;
import org.adjective.syntactic.parser.type.MemberType;

public class ASTEnumDeclaration extends BaseNode implements IsTypeDeclaration
{
    public ASTEnumDeclaration(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTIdentifier getName()
    {
        return getFirstChild().as(ASTIdentifier.class);
    }

    public ASTImplementsList getImplementsNode()
    {
        return optionalChild(ASTImplementsList.class);
    }

    public ASTEnumBody getBody()
    {
        return getLastChild().as(ASTEnumBody.class);
    }

    @Override
    public MemberType getMemberType()
    {
        return MemberType.ENUM;
    }

    @Override
    public DeclarationType getDeclarationType()
    {
        return DeclarationType.ENUM;
    }
}
