package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ConstructorReference;
import org.adjective.syntactic.parser.node.ExpressionNode;
import org.adjective.syntactic.parser.node.StatementNode;

public class ASTExplicitConstructorInvocation extends BaseNode implements StatementNode
{
    public ASTExplicitConstructorInvocation(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ExpressionNode getContextExpression()
    {
        if (jjtGetNumChildren() > 2 && !getFirstChild().is(ASTTypeArguments.class))
        {
            return getFirstChild().as(ExpressionNode.class);
        }
        return null;
    }

    public ASTTypeArguments getTypeArguments()
    {
        return optionalChild(ASTTypeArguments.class);
    }

    public ConstructorReference getTarget()
    {
        return child(jjtGetNumChildren() - 2).as(ConstructorReference.class);
    }

    public ASTArguments getArguments()
    {
        return getLastChild().as(ASTArguments.class);
    }
}
