package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.IsMember;
import org.adjective.syntactic.parser.type.MemberType;
import org.adjective.syntactic.parser.node.TypeNode;

public class ASTFieldDeclaration extends BaseNode implements IsMember
{
    public ASTFieldDeclaration(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public MemberType getMemberType()
    {
        return MemberType.FIELD;
    }

    public TypeNode getDeclaredType()
    {
        return getFirstChild().as(TypeNode.class);
    }

    public Iterable<ASTVariableDeclarator> getFields()
    {
        return super.children(ASTVariableDeclarator.class, 1);
    }
}
