package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.jj.JavaParserConstants;
import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.LambdaParameter;

public class ASTIdentifier extends BaseNode implements LambdaParameter
{
    public ASTIdentifier(int id)
    {
        super(id);
    }

    public ASTIdentifier(final String image)
    {
        this(JavaParserTreeConstants.JJTIDENTIFIER);
        jjtSetFirstToken(makeToken(JavaParserConstants.IDENTIFIER, image));
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public String getIdentifier()
    {
        return jjtGetFirstToken().image;
    }

}
