/* ------------------------------------------------------------------------
 * Copyright 2013 Tim Vernum
 * ------------------------------------------------------------------------
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ------------------------------------------------------------------------
 */
package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.MemberExpressionNode;

public class ASTIdentifierSuffix extends BaseNode implements MemberExpressionNode
{
    public ASTIdentifierSuffix(final int i)
    {
        super(i);
    }

    public ASTIdentifierSuffix(ASTTypeArguments typeArguments, ASTIdentifier identifier)
    {
        this(JavaParserTreeConstants.JJTIDENTIFIERSUFFIX);
        setChildren(typeArguments, identifier);
    }

    public ASTIdentifierSuffix(ASTIdentifier identifier)
    {
        this(JavaParserTreeConstants.JJTIDENTIFIERSUFFIX);
        setChildren(identifier);
    }

    @Override
    public <R, T> R jjtAccept(final JavaParserVisitor<R, T> visitor, final T data)
    {
        return visitor.visit(this, data);
    }

    public ASTIdentifier getIdentifier()
    {
        return getLastChild().as(ASTIdentifier.class);
    }
}
