package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.StatementNode;

public class ASTIfStatement extends BaseNode implements StatementNode
{
    public ASTIfStatement(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTExpression getCondition()
    {
        return getFirstChild().as(ASTExpression.class);
    }

    public StatementNode getIfBody()
    {
        return child(1).as(StatementNode.class);
    }

    public boolean hasElse()
    {
        return jjtGetNumChildren() == 3;
    }

    public StatementNode getElseBody()
    {
        return child(2).as(StatementNode.class);
    }
}
