package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;

public class ASTImportDeclaration extends BaseNode
{
    public ASTImportDeclaration(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public boolean isStatic()
    {
        return getFirstChild().is(ASTStaticImport.class);
    }

    public boolean isOnDemand()
    {
        return getLastChild().is(ASTWildcardImport.class);
    }

    public ASTQualifiedIdentifier getIdentifier()
    {
        return child(ASTQualifiedIdentifier.class);
    }
}
