package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.jj.JavaParserConstants;

public class ASTInitializer extends BaseNode
{
    public ASTInitializer(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public boolean isStaticInitializer()
    {
        return jjtGetFirstToken().kind == JavaParserConstants.STATIC;
    }

    public ASTBlock getBlock()
    {
        return getFirstChild().as(ASTBlock.class);
    }
}
