package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;

public class ASTLambdaBody extends BaseNode
{
    public ASTLambdaBody(int id)
    {
        super(id);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public boolean isExpression()
    {
        return getFirstChild().is(ASTExpression.class);
    }

    public ASTExpression getExpression()
    {
        return getFirstChild().as(ASTExpression.class);
    }

    public ASTBlock getBlock()
    {
        return getFirstChild().as(ASTBlock.class);
    }
}
