package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;

public class ASTLambdaExpression extends BaseNode implements ExpressionNode
{
    public ASTLambdaExpression(int id)
    {
        super(id);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTLambdaParameters getParameters()
    {
        return getFirstChild().as(ASTLambdaParameters.class);
    }

    public ASTLambdaBody getBody()
    {
        return child(1).as(ASTLambdaBody.class);
    }
}
