package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionSuffix;

public class ASTMemberReference extends BaseNode implements ExpressionSuffix
{
    public ASTMemberReference(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTTypeArguments getTypeArguments()
    {
        return optionalChild(ASTTypeArguments.class);
    }

    public boolean isConstructorReference()
    {
        return getLastChild().is(ASTNew.class);
    }

    public ASTIdentifier getName()
    {
        return getLastChild().as(ASTIdentifier.class);
    }
}
