package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;

import java.util.HashMap;
import java.util.Map;

public class ASTMemberValuePairs extends BaseNode
{
    public ASTMemberValuePairs(int id)
    {
        super(id);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public Map<ASTIdentifier, ASTMemberValue> toMap()
    {
        Map<ASTIdentifier, ASTMemberValue> map = new HashMap<ASTIdentifier, ASTMemberValue>(jjtGetNumChildren());
        for (ASTMemberValuePair pair : getPairs())
        {
            map.put(pair.getName(), pair.getValue());
        }
        return map;
    }

    public Iterable<ASTMemberValuePair> getPairs()
    {
        return allChildren(ASTMemberValuePair.class);
    }
}
