package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.jj.JavaParser;
import org.adjective.syntactic.parser.jj.JavaParserConstants;
import org.adjective.syntactic.parser.jj.Token;
import org.adjective.syntactic.parser.node.BaseNode;

public class ASTMethodBody extends BaseNode
{
    public ASTMethodBody(int id)
    {
        super(id);
    }

    public ASTMethodBody(final ASTBlock block)
    {
        this(JavaParserTreeConstants.JJTMETHODBODY);
        appendChild(block);
        Token token = block.jjtGetFirstToken();
        if (token == null)
        {
            token = makeToken(JavaParserConstants.LBRACE, "{");
        }
        jjtSetFirstToken(token);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public boolean isEmpty()
    {
        return super.isEmpty();
    }

    public boolean isDefaultMethod()
    {
        return jjtGetFirstToken().kind == JavaParser._DEFAULT;
    }

    public ASTBlock getBlock()
    {
        return getFirstChild().as(ASTBlock.class);
    }
}
