package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.HasAnnotations;

public class ASTPackageDeclaration extends BaseNode implements HasAnnotations
{
    public ASTPackageDeclaration(int id)
    {
        super(id);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public Iterable<ASTAnnotation> getAnnotations()
    {
        return getAnnotationsNode().getAnnotations();
    }

    public ASTAnnotations getAnnotationsNode()
    {
        return child(ASTAnnotations.class);
    }

    public ASTQualifiedIdentifier getPackageName()
    {
        return child(ASTQualifiedIdentifier.class);
    }
}
