package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;
import org.adjective.syntactic.parser.node.ExpressionSuffix;
import org.adjective.syntactic.parser.node.Nodes;

public class ASTPrimaryExpression extends BaseNode implements ExpressionNode
{
    public ASTPrimaryExpression(int id)
    {
        super(id);
    }

    public ASTPrimaryExpression(ExpressionNode prefix, Iterable<ExpressionSuffix> suffixes)
    {
        this(JavaParserTreeConstants.JJTPRIMARYEXPRESSION);
        appendChild(prefix);
        appendChildren(suffixes);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ExpressionNode getPrefix()
    {
        return getFirstChild().as(ExpressionNode.class);
    }

    public Nodes<ExpressionSuffix> getSuffixes()
    {
        return super.children(ExpressionSuffix.class, 1, jjtGetNumChildren());
    }

    public void setTo(final ExpressionNode prefix, final Iterable<ExpressionSuffix> suffixes)
    {
        jjtClearChildren();
        appendChild(prefix);
        for (ExpressionSuffix suffix : suffixes)
        {
            appendChild(suffix);
        }
    }
}
