package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;

public class ASTQualifiedIdentifier extends BaseNode implements ExpressionNode
{
    public ASTQualifiedIdentifier(int id)
    {
        super(id);
    }

    public ASTQualifiedIdentifier(String... names)
    {
        this(JavaParserTreeConstants.JJTQUALIFIEDIDENTIFIER);
        final ASTIdentifier[] components = new ASTIdentifier[names.length];
        for (int i = 0; i < names.length; i++)
        {
            components[i] = new ASTIdentifier(names[i]);
        }
        setChildren(components);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public Iterable<ASTIdentifier> getIdentifierComponents()
    {
        return allChildren(ASTIdentifier.class);
    }

    public String getName()
    {
        return super.getIdentifierName(getIdentifierComponents());
    }

    public ASTIdentifier getLastIdentifier()
    {
        return getLastChild().as(ASTIdentifier.class);
    }
}
