package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;
import org.adjective.syntactic.parser.node.StatementNode;

public class ASTReturnStatement extends BaseNode implements StatementNode
{
    public ASTReturnStatement(int id)
    {
        super(id);
    }

    public ASTReturnStatement(final ASTExpression expression)
    {
        this(JavaParserTreeConstants.JJTRETURNSTATEMENT);
        setChildren(expression);
    }

    public ASTReturnStatement(final ExpressionNode expression)
    {
        this(new ASTExpression(expression));
    }

    public ASTExpression getExpression()
    {
        return getFirstChild().as(ASTExpression.class);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }
}
