package org.adjective.syntactic.parser.ast;

import java.util.Collections;
import java.util.Map;

public class ASTSingleMemberAnnotation extends org.adjective.syntactic.parser.ast.ASTAnnotation
{
    public ASTSingleMemberAnnotation(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, final T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public Map<ASTIdentifier, ASTMemberValue> getValues()
    {
        return Collections.singletonMap(null, getValue());
    }

    public ASTMemberValue getValue()
    {
        return child(ASTMemberValue.class);
    }
}
