package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;

public class ASTStatementExpression extends BaseNode implements ExpressionNode
{
    public ASTStatementExpression(int id)
    {
        super(id);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ExpressionNode getBaseExpression()
    {
        return getFirstChild().as(ExpressionNode.class);
    }

    public boolean isPostfixExpression()
    {
        return jjtGetNumChildren() == 2;
    }

    public ASTUnaryOperator getPostfixOperator()
    {
        return child(1).as(ASTUnaryOperator.class);
    }

    public boolean isAssignmentExpression()
    {
        return jjtGetNumChildren() == 3;
    }

    public ASTAssignmentOperator getAssignmentOperator()
    {
        return child(1).as(ASTAssignmentOperator.class);
    }

    public ASTExpression getAssignmentRHS()
    {
        return child(2).as(ASTExpression.class);
    }
}
