package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.StatementNode;

public class ASTSwitchStatement extends BaseNode implements StatementNode
{
    public ASTSwitchStatement(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTExpression getSwitchExpression()
    {
        return getFirstChild().as(ASTExpression.class);
    }

    public Iterable<ASTSwitchCase> getSwitchCases()
    {
        return findChildren(ASTSwitchCase.class);
    }
}
