package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;

public class ASTTernaryExpression extends BaseNode implements ExpressionNode
{
    public ASTTernaryExpression(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ExpressionNode getCondition()
    {
        return getFirstChild().as(ExpressionNode.class);
    }

    public ExpressionNode getTrueExpression()
    {
        return child(1).as(ExpressionNode.class);
    }

    public ExpressionNode getFalseExpression()
    {
        return child(2).as(ExpressionNode.class);
    }
}
