/*
 * ------------------------------------------------------------------------
 *  Copyright 2013 Tim Vernum
 *  ------------------------------------------------------------------------
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  ------------------------------------------------------------------------
 */

/* Generated By:JJTree: Do not edit this line. ASTTryStatement.java Version 4.3 */
/* JavaCCOptions:MULTI=true,NODE_USES_PARSER=false,VISITOR=true,TRACK_TOKENS=true,NODE_PREFIX=AST,NODE_EXTENDS=,NODE_FACTORY=,SUPPORT_CLASS_VISIBILITY_PUBLIC=true */
package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.StatementNode;

public class ASTTryStatement extends BaseNode implements StatementNode
{
    public ASTTryStatement(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public boolean hasResource()
    {
        return getResourcesSpecification() != null;
    }

    public ASTResourcesSpecification getResourcesSpecification()
    {
        return optionalChild(ASTResourcesSpecification.class);
    }

    public ASTBlock getBody()
    {
        final int i = hasResource() ? 1 : 0;
        return child(i).as(ASTBlock.class);
    }

    public ASTCatchClauses getCatchClauses()
    {
        return child(ASTCatchClauses.class);
    }

    public boolean hasFinallyBlock()
    {
        return getLastChild().is(ASTBlock.class);
    }

    public ASTBlock getFinallyBlock()
    {
        if (hasFinallyBlock())
        {
            return getLastChild().as(ASTBlock.class);
        }
        else
        {
            return null;
        }
    }

}
