package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.name.TypeParameter;
import org.adjective.syntactic.parser.node.BaseNode;

public class ASTTypeArguments extends BaseNode
{
    public ASTTypeArguments(int id)
    {
        super(id);
    }

    public ASTTypeArguments(final TypeParameter[] parameters)
    {
        this(JavaParserTreeConstants.JJTTYPEARGUMENTS);
        ASTTypeArgument[] children = new ASTTypeArgument[parameters.length];
        for (int i = 0; i < parameters.length; i++)
        {
            if (parameters[i] instanceof ASTTypeArgument)
            {
                children[i] = (ASTTypeArgument) parameters[i];
            }
            else
            {
                children[i] = new ASTTypeArgument(parameters[i]);
            }
        }
        setChildren(children);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public Iterable<ASTTypeArgument> getArguments()
    {
        return allChildren(ASTTypeArgument.class);
    }

    public TypeParameter[] getParameters()
    {
        TypeParameter[] parameters = new TypeParameter[jjtGetNumChildren()];
        for (int i = 0; i < parameters.length; i++)
        {
            parameters[i] = child(i).as(ASTTypeArgument.class);
        }
        return parameters;
    }
}
