package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;

public class ASTTypeParameter extends BaseNode
{
    public ASTTypeParameter(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTIdentifier getIdentifier()
    {
        return getFirstChild().as(ASTIdentifier.class);
    }

    public ASTTypeBound getTypeBound()
    {
        return optionalChild(ASTTypeBound.class);
    }
}
