package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.node.ExpressionNode;

public class ASTVariableDeclarator extends BaseNode
{
    public ASTVariableDeclarator(int id)
    {
        super(id);
    }

    public <R, T> R jjtAccept(JavaParserVisitor<R, T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    public ASTIdentifier getIdentifier()
    {
        return child(ASTIdentifier.class);
    }

    public ASTArraySuffixList getArraySuffix()
    {
        return child(ASTArraySuffixList.class);
    }

    public boolean hasInitializer()
    {
        return jjtGetNumChildren() == 3;
    }

    public ExpressionNode getInitializer()
    {
        return super.child(2).as(ExpressionNode.class);
    }

    public void replaceInitializer(final ExpressionNode expression)
    {
        super.jjtAddChild(expression, 2);
    }
}
