package org.adjective.syntactic.parser.ast;

import org.adjective.syntactic.parser.node.BaseNode;
import org.adjective.syntactic.parser.type.BaseType;
import org.adjective.syntactic.parser.node.TypeNode;

public class ASTVoidType extends BaseNode implements TypeNode
{
    public ASTVoidType(int id)
    {
        super(id);
    }

    public ASTVoidType()
    {
        this(JavaParserTreeConstants.JJTVOIDTYPE);
    }

    public <R,T> R jjtAccept(JavaParserVisitor<R,T> visitor, T data)
    {
        return visitor.visit(this, data);
    }

    @Override
    public BaseType getBaseType()
    {
        return BaseType.VOID;
    }

    @Override
    public String getTypeName()
    {
        return "void";
    }

    @Override
    public ASTParameterizedIdentifier[] getParameterizedTypeName()
    {
        return null;
    }

    @Override
    public int getArrayDepth()
    {
        return 0;
    }
}
