/* ------------------------------------------------------------------------
 * Copyright 2013 Tim Vernum
 * ------------------------------------------------------------------------
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ------------------------------------------------------------------------
 */
package org.adjective.syntactic.parser.name;

import org.adjective.syntactic.parser.type.JavaType;

public class SimpleTypeParameter implements TypeParameter
{
    private final Kind _kind;
    private final JavaType _type;

    public SimpleTypeParameter(final Kind kind, final JavaType type)
    {
        _kind = kind;
        _type = type;
    }

    @Override
    public Kind getKind()
    {
        return _kind;
    }

    @Override
    public JavaType getType()
    {
        return _type;
    }
}
