/*
 * ------------------------------------------------------------------------
 *  Copyright 2013 Tim Vernum
 *  ------------------------------------------------------------------------
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  ------------------------------------------------------------------------
 */
package org.adjective.syntactic.parser.name;

import org.adjective.syntactic.parser.ast.ASTIdentifier;
import org.adjective.syntactic.parser.name.ParameterizedName;
import org.adjective.syntactic.parser.name.TypeParameter;

public class UnparameterizedName implements ParameterizedName
{
    private final String _name;

    public UnparameterizedName(final String name)
    {
        _name = name;
    }

    public UnparameterizedName(final ASTIdentifier identifier)
    {
        this(identifier.getIdentifier());
    }

    @Override
    public TypeParameter[] getParameters()
    {
        return new TypeParameter[0];
    }

    @Override
    public String getName()
    {
        return _name;
    }
}
