/*
 * ------------------------------------------------------------------------
 *  Copyright 2013 Tim Vernum
 *  ------------------------------------------------------------------------
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  ------------------------------------------------------------------------
 */
package org.adjective.syntactic.parser.util;

import org.adjective.syntactic.parser.ast.*;

public class DefaultVisitor<R, T> implements JavaParserVisitor<R, T>
{
    @Override
    public R visit(final SimpleNode node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTCompilationUnit node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTPackageDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAnnotations node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTImports node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTImportDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTStaticImport node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTWildcardImport node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTypes node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTModifiers node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTypeDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTClassOrInterfaceDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTClassOrInterfaceKeyword node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTIdentifier node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTExtendsList node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTImplementsList node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTEnumDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTEnumBody node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTEnumConstants node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTEnumConstant node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTypeParameters node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTypeParameter node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTypeBound node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTClassOrInterfaceBody node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTClassOrInterfaceBodyElement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMember node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTFieldDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTVariableDeclarator node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArrayInitializer node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMethodDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMethodBody node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArraySuffixList node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArraySuffix node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTFormalParameters node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTFormalParameter node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTVariableModifiers node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTVarArgs node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTConstructorDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTConstructorBody node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTExplicitConstructorInvocation node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTInitializer node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTReferenceType node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTClassOrInterfaceType node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTParameterizedIdentifier node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTypeArguments node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTypeArgument node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTWildcardBounds node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTPrimitiveType node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTVoidType node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTQualifiedIdentifier node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTNameList node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAssignmentOperator node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTernaryExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLogicalOrExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLogicalAndExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTInclusiveOrExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTExclusiveOrExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAndExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTEqualityExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTBinaryOperator node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTInstanceOfExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTRelationalExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTShiftExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAdditiveExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMultiplicativeExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTUnaryExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTPrefixExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTUnaryOperator node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTPostfixExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTCastExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTPrimaryExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTSuperExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTBracketExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMemberSuffix node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTIdentifierSuffix node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMemberReference node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTNew node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTIntegerLiteral node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTFloatingPointLiteral node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTCharacterLiteral node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTStringLiteral node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTThis node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTSuper node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTClassReference node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArrayIndex node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTBooleanLiteral node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTNullLiteral node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArguments node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArgumentList node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAllocationExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArrayDimensions node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTDefinedArrayDimension node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTUndefinedArrayDimension node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTArrayWithInit node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTExpressionStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAssertStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLabeledStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTBlock node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTVariableDeclarationStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLocalVariableDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTEmptyStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTStatementExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTSwitchStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTSwitchCase node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTSwitchLabel node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTIfStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTWhileStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTDoStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTForStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTForEach node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTernaryForCondition node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTStatementExpressionList node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTBreakStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTContinueStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTReturnStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTThrowStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTSynchronizedStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTTryStatement node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTResourcesSpecification node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTResource node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTCatchClauses node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTCatchClause node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTCatchParameter node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTCatchType node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTNormalAnnotation node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMarkerAnnotation node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTSingleMemberAnnotation node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMemberValuePairs node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMemberValuePair node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMemberValue node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTMemberValueArrayInitializer node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAnnotationTypeDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAnnotationTypeBody node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAnnotationTypeMemberDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTAnnotationMethodDeclaration node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTDefaultValue node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLambdaExpression node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLambdaParameters node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLambdaParameterList node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }

    @Override
    public R visit(final ASTLambdaBody node, final T data)
    {
        node.childrenAccept(this, data);
        return null;
    }
}

