/* ------------------------------------------------------------------------
 * Copyright 2013 Tim Vernum
 * ------------------------------------------------------------------------
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ------------------------------------------------------------------------
 */
package org.adjective.syntactic.convert.j8to7.type;

import org.adjective.syntactic.parser.type.BaseType;
import org.junit.*;

import static org.junit.Assert.*;

public class ClassTypeTest
{
    @Test
    public void testPrimitiveArray()
    {
        Class cls = byte[][].class;
        final ClassType type = new ClassType(cls);
        assertEquals(2, type.getArrayDepth());
        assertEquals(BaseType.BYTE, type.getBaseType());
        assertEquals("byte", type.getTypeName());
        assertEquals(1, type.getParameterizedTypeName().length);
        assertEquals("byte", type.getParameterizedTypeName()[0].getName());
        assertEquals(0, type.getParameterizedTypeName()[0].getParameters().length);
    }
}
