/*
 * ------------------------------------------------------------------------
 *  Copyright 2013 Tim Vernum
 *  ------------------------------------------------------------------------
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *  ------------------------------------------------------------------------
 */
package org.adjective.syntactic.parser.ast;

import org.junit.Assert;
import org.junit.Test;

import java.math.BigDecimal;
import java.math.BigInteger;

public class ASTFloatingPointLiteralTest
{
    @Test
    public void testParseHex() throws Exception
    {
        String image = ("76c4da0.04b923ep7").toLowerCase();
        System.out.println(image);
        ASTFloatingPointLiteral.FloatingPointValue value = ASTFloatingPointLiteral.parseHex(image, true);
        Assert.assertEquals(new BigDecimal(0x76c4da0.04b923ep0), value.base);
        Assert.assertEquals(new BigInteger("7"), value.exponent);
        Assert.assertEquals(true, value.isDouble);
    }
}
